core/core/urls.py
from django.conf import settings
from django.conf.urls import url, include
from django.contrib import admin
from django.conf.urls.static import static
from client.views import login_view, logout_view

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('client.urls')),
    url(r'^clients/', include('client.urls', namespace='client')),
    url(r'^visit/', include('vist.urls', namespace='visit')),
    url(r'^safe/', include('safe.urls', namespace='safe')),
    url(r'^appointment/', include('appointments.urls', namespace='appointment')),
    url(r'^lab/', include('labs.urls', namespace='labs')),
    url(r'^login/$', login_view.as_view(), name='login'),
    url(r'^logout/$', logout_view.as_view(), name='logout'),

]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

core/labs/urls.py
from django.conf.urls import url
from .views import (
    ListLabs, AddLab, DeleteLab, AddItemType, ListItemType,
    AddItemToLab, LabDetailView, DeleteItemFromLab, LabsDue,
    DeleteItemType
)
from django.views.generic.base import RedirectView

urlpatterns = [
    url(r'^$', ListLabs.as_view(), name="index"),
    url(r'^itemstype$', ListItemType.as_view(), name="item-type-index"),
    url(r'^add/$', AddLab.as_view(), name="add"),
    url(r'^add/item/type$', AddItemType.as_view(), name="add-item-type"),
    url(r'^due/$', LabsDue.as_view(), name="due"),
    url(r'^add/item/$', AddItemToLab.as_view(), name="add-item"),
    url(r'^(?P<pk>\d+)/delete/item/$', DeleteItemFromLab.as_view(), name="delete-item"),
    url(r'^(?P<pk>\d+)/delete/item/type$', DeleteItemType.as_view(), name="delete-item-type"),
    url(r'^(?P<pk>\d+)/delete/$', DeleteLab.as_view(), name="delete"),
    # url(r'^(?P<pk>\d+)/update/$', UpdateClientView.as_view(), name="update"),
    url(r'^(?P<pk>\d+)/show/$', LabDetailView.as_view(), name="show"),
    # url(r'^search/$', TweetListView.as_view(), name="list"),

]

core/labs/models.py
from django.db import models
from client.models import Client


# Create your models here.

class Lab(models.Model):
    title = models.CharField(max_length=255, null=False, blank=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.title

    def get_due(self):
        total_paid = 0
        for payment in self.item_set.all():
            total_paid += payment.amount
        return total_paid


class ItemType(models.Model):
    title = models.CharField(max_length=255, null=False, blank=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.title


class Item(models.Model):
    lab = models.ForeignKey(Lab)
    client = models.ForeignKey(Client)
    itemtype = models.ForeignKey(ItemType)
    amount = models.FloatField(default=0, blank=False, null=False)
    count = models.IntegerField(default=1, blank=False, null=False)
    created_at = models.DateTimeField(auto_now_add=True)
    updated_at = models.DateTimeField(auto_now=True)

    def __str__(self):
        return self.itemtype.title

core/labs/forms.py
from django import forms
from .models import Lab, Item, ItemType


class AddLabForm(forms.ModelForm):
    class Meta:
        model = Lab
        fields = ['title']
        labels = {
            "title": "الاسم"
        }
        widgets = {
            'title': forms.TextInput(attrs={'class': 'form-control'}),
        }


class AddItemToLabForm(forms.ModelForm):
    class Meta:
        model = Item
        labels = {
            "lab": "المعمل", "client": "العميل", "itemtype": "التركيبة", "count": "العدد", "amount": "السعر"
        }

        fields = ['lab', 'client', 'itemtype', 'count', 'amount', ]
        widgets = {
            'lab': forms.Select(attrs={'class': 'form-control'}),
            'client': forms.Select(attrs={'class': 'form-control'}),
            'itemtype': forms.Select(attrs={'class': 'form-control'}),
            'count': forms.NumberInput(attrs={'class': 'form-control'}),
            'amount': forms.NumberInput(attrs={'class': 'form-control'}),
        }


class AddItemTypeForm(forms.ModelForm):
    class Meta:
        model = ItemType
        labels = {
            "title": "اسم التركيبة",
        }

        fields = ['title']
        widgets = {
            'title': forms.TextInput(attrs={'class': 'form-control'}),
        }

core/labs/views.py
from django.shortcuts import render
from .models import Lab, Item, ItemType
from django.urls import reverse_lazy, reverse
from .forms import AddLabForm, AddItemToLabForm, AddItemTypeForm
from django.views.generic import View, CreateView, ListView, DeleteView, DetailView


# Create your views here.


class ListLabs(ListView):
    model = Lab
    template_name = "partials/labs/list_view.html"


class AddLab(CreateView):
    model = Lab
    form_class = AddLabForm
    template_name = "partials/labs/add_view.html"
    success_url = reverse_lazy("labs:index")


class DeleteLab(DeleteView):
    model = Lab
    template_name = "partials/labs/delete_view.html"
    success_url = reverse_lazy("labs:index")


class AddItemToLab(CreateView):
    model = Item
    form_class = AddItemToLabForm
    template_name = "partials/labs/item/add_view.html"
    success_url = reverse_lazy("labs:index")


class LabDetailView(DetailView):
    model = Lab
    template_name = "partials/labs/detail_view.html"


class DeleteItemFromLab(DeleteView):
    model = Item
    template_name = "partials/labs/delete_view.html"
    success_url = reverse_lazy("labs:index")


class LabsDue(View):
    template_name = "partials/labs/due_list_view.html"

    def get(self, request, *args, **kwargs):
        object_list = Item.objects.filter(created_at__range=(request.GET.get('from'), request.GET.get('to')))
        overall = 0
        for item in object_list:
            overall += item.amount

        return render(request, self.template_name, {"object_list": object_list, "overall": overall})


class ListItemType(ListView):
    model = ItemType
    template_name = "partials/labs/item/list_item_type.html"


class AddItemType(CreateView):
    model = ItemType
    form_class = AddItemTypeForm
    template_name = "partials/labs/item/add_item_type.html"
    success_url = reverse_lazy("labs:item-type-index")


class DeleteItemType(DeleteView):
    model = ItemType
    template_name = "partials/labs/delete_view.html"
    success_url = reverse_lazy("labs:item-type-index")

core/templates/partials/labs/add_view.html
{% extends "base.html" %} {% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h1 class="page-header text-center">اضافة معمل</h1>
                <div class="col-lg-12">
                    <div class="panel panel-default center-block">
                        <div class="panel-body">
                            <div class="tab-content">
                                <div id="levelInfo" class="tab-pane fade in active">
                                    <form action="" method="post">
                                        {% csrf_token %}
                                        {% if form.errors %}
                                            {% for field in form %}
                                                {% for error in field.errors %}
                                                    <div class="alert alert-danger">
                                                        <strong>{{ error|escape }}</strong>
                                                    </div>
                                                {% endfor %}
                                            {% endfor %}
                                            {% for error in form.non_field_errors %}
                                                <div class="alert alert-danger">
                                                    <strong>{{ error|escape }}</strong>
                                                </div>
                                            {% endfor %}
                                        {% endif %}
                                        </ol>
                                        {{ form.as_p }}
                                        <input type="submit" value="اضف" class="btn btn-success btn-block">
                                    </form>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- /.col-lg-12 -->
    </div>
{% endblock content %}

core/templates/partials/labs/delete_view.html
{% extends "base.html" %}
{% block content %}
    <div id="page-wrapper">
      <div class="row">
        <div class="col-lg-12">
          <h1 class="page-header text-center"><span style="color:red;"></span> {{object.title}}</h1>
          <div class="col-lg-12">
            <div class="panel panel-default center-block">
              <div class="panel-body">
                <div class="tab-content">
                  <div id="levelInfo" class="tab-pane fade in active">
                    <form action="" method="post">{% csrf_token %}
                      <h4><p>هل انت متاكد من حذف <span style="color:green;">{{object.title}}</span></p></h4>
                      <hr>
                      <input class="btn btn-danger" type="submit" value="احذف" />
                    </form>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- /.col-lg-12 -->
    </div>
{% endblock content %}

core/templates/partials/labs/detail_view.html
{% extends "base.html" %}
{% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h1 class="page-header">{{ object.title }}

                </h1>
            </div>
            <div class="col-lg-12">
                <table class="table">

                    <tr>
                        <th>المسلسل</th>
                        <td>{{ object.id }}</td>
                    </tr>
                    <tr>
                        <th>الاسم</th>
                        <td>{{ object.title }}</td>
                    </tr>


                </table>
                <!-- /.table-responsive -->
                <table width="100%" class="table table-striped table-bordered table-hover" id="dataTables-example">
                    <thead>
                    <tr>
                        <th>المسلسل</th>
                        <th class="text-center">التركيبة</th>
                        <th class="text-center">العميل</th>
                        <th class="text-center">العدد</th>
                        <th class="text-center">السعر</th>
                        <th class="text-center">تاريخ الانشاء</th>
                        <th class="text-center">تاريخ التعديل</th>
                        <th class="text-center">الاعدادات</th>

                    </tr>
                    </thead>
                    <tbody>
                    {% for obj in object.item_set.all %}
                        <tr id="ddata-{obj.id}">
                            <td>{{ obj.id }}</td>
                            <td>{{ obj.itemtype.title }}</td>
                            <td><a href="{% url 'client:show' obj.client.id %}">{{ obj.client.name }} --
                                ({{ obj.client.mobile }})</a></td>
                            <td>
                                {{ obj.count }}
                            </td>
                            <td>{{ obj.amount }}</td>
                            <td>{{ obj.created_at|timesince }} ago.</td>
                            <td>{{ obj.updated_at|timesince }} ago.</td>
                            <td>
                                <a href="{% url 'labs:delete-item' obj.id %}" class="btn btn-danger" title="Delete"
                                   data-original-title="Delete">
                                    <i class="fa fa-trash"></i>
                                </a>
                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
            </div>
            <!-- /.col-lg-12 -->
        </div>
        <!-- /.row -->

    </div>
{% endblock content %}

core/templates/partials/labs/due_list_view.html
{% extends "base.html" %}

{% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h1 class="page-header">المعامل
                <h4 class="text-primary">Total Amount: {{ overall }}</h4>

                </h1>
                {% if messages %}
                    <ol class="breadcrumb">
                        <div class="alert alert-success">
                            <ul class="messages">
                                {% for message in messages %}
                                    <li{% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>
                                {% endfor %}
                            </ul>
                        </div>
                    </ol>
                {% endif %}
            </div>
            <div class="col-lg-12">
                <table width="100%" class="table table-striped table-bordered table-hover" id="dataTables-example">
                    <thead>
                    <tr>
                        <th>التسلسل</th>
                        <th class="text-center">الاسم</th>
                        <th class="text-center">المعمل</th>
                        <th class="text-center">القيمة</th>
                        <th class="text-center">تاريخ الانشاء</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for obj in object_list %}
                        <tr id="ddata-{obj.id}">
                            <td>{{ obj.id }}</td>
                            <td>{{ obj.itemtype.title }}</td>
                            <td>{{ obj.lab.title }}</td>
                            <td>{{ obj.amount }}</td>
                            <td>{{ obj.created_at|timesince }} ago.</td>

                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
                <!-- /.table-responsive -->

            </div>
            <!-- /.col-lg-12 -->
        </div>
        <!-- /.row -->

    </div>
{% endblock content %}

core/templates/partials/labs/list_view.html
{% extends "base.html" %}

{% block content %}
    <div id="page-wrapper">
        <div class="row">
            <div class="col-lg-12">
                <h1 class="page-header">المعامل

                </h1>
                {% if messages %}
                    <ol class="breadcrumb">
                        <div class="alert alert-success">
                            <ul class="messages">
                                {% for message in messages %}
                                    <li{% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>
                                {% endfor %}
                            </ul>
                        </div>
                    </ol>
                {% endif %}
            </div>
            <div class="col-lg-12">
                <table width="100%" class="table table-striped table-bordered table-hover" id="dataTables-example">
                    <thead>
                    <tr>
                        <th>التسلسل</th>
                        <th class="text-center">الاسم</th>
                        <th class="text-center">تاريخ الانشاء</th>
                        <th class="text-center">تاريخ التعديل</th>
                        <th class="text-center">الاعدادات</th>
                    </tr>
                    </thead>
                    <tbody>
                    {% for obj in object_list %}
                        <tr id="ddata-{obj.id}">
                            <td>{{ obj.id }}</td>
                            <td>{{ obj.title }}</td>
                            <td>{{ obj.created_at|timesince }} ago.</td>
                            <td>{{ obj.updated_at|timesince }} ago.</td>
                            <td>
                                <a href="{% url 'labs:show' obj.id %}" class="btn btn-success" title="Show"
                                   data-original-title="Show">
                                    <i class="fa fa-eye"></i>

                                </a>
                                <a href="{% url 'labs:delete' obj.id %}" class="btn btn-danger" title="Delete"
                                   data-original-title="Delete">
                                    <i class="fa fa-trash"></i>

                                </a>
                            </td>
                        </tr>
                    {% endfor %}
                    </tbody>
                </table>
                <!-- /.table-responsive -->

            </div>
            <!-- /.col-lg-12 -->
        </div>
        <!-- /.row -->

    </div>
{% endblock content %}